//
// $Id: RADIUSplugin.h,v 1.3 2005/03/02 23:51:40 hweiss Exp $
//
// RADIUS Plugin for pGina
// Copyright (c) 2004, 2005 Holger Weiss <holger@ZEDAT.FU-Berlin.DE>
// Copyright (c) 2005 Kostas Kalevras <kkalev@noc.ntua.gr>
//
// ---------------------------------------------------------------------------
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc., 59
// Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
//

#ifndef RADIUSplugin_H
#define RADIUSplugin_H

#pragma once

#ifndef __AFXWIN_H__
#error include 'stdafx.h' before including this file for PCH
#endif				// __AFXWIN_H__

#define VERSION		"RADIUSplugin 0.2 | (c) 2004, 2005 Holger Weiss"

// ---------------------------------------------------------------------------
// RADIUSplugin API

// Macros
#define RADIUSPLUGIN_API	extern "C" __declspec(dllexport)

// pGinaInfo structure
typedef struct pGinaInfo
{
	LPTSTR  pathMSGina;
	LPTSTR  pathPlugin;
	LPTSTR  pathProfile;
	LPTSTR  mapPaths;
	LPTSTR  Username;
	LPTSTR  Password;
	LPTSTR  homeDir;
	BOOL    isAdmin;
	BOOL    disabled;
	int     authType;
	HANDLE  hUser;
	LPTSTR  userGroups;
	LPTSTR  userDescription;
	LPTSTR  userFullName;
	BOOL    allowPassChange;
	LPTSTR  errorString;
	LPTSTR  defaultDomain;
	LPTSTR  pathProfileDefault;
	DWORD   sessionTimeout;
}
pGinaInfo;

// RADIUSplugin API functions called by pGina
RADIUSPLUGIN_API BOOL    UserLogin(LPTSTR, LPTSTR, pGinaInfo *settingsInfo);
RADIUSPLUGIN_API BOOL    ChangeUserPassword(LPTSTR,LPTSTR,LPTSTR);
RADIUSPLUGIN_API LPTSTR  AboutPlugin(void);
RADIUSPLUGIN_API void    ChangePluginSettings(void);
RADIUSPLUGIN_API void    LoginHook(pGinaInfo *settingsInfo);
RADIUSPLUGIN_API void    LogoutHook(pGinaInfo *settingsInfo);
RADIUSPLUGIN_API BOOL    IsRequired(void);

#endif				// RADIUSplugin_H
